// Generated by LiveScript 1.2.0
(function(){
  var obi, sinon, sinonChai, chai, expect, o, x;
  obi = require('../lib');
  sinon = require('sinon');
  sinonChai = require('sinon-chai');
  chai = require('chai');
  expect = chai.expect;
  chai.use(sinonChai);
  o = it;
  x = it.skip;
  describe('obi', function(){
    describe('#done', function(){
      context('when not given an initial object', function(){
        beforeEach(function(){
          return this.obi = obi();
        });
        return o('returns an empty object', function(){
          return expect(this.obi.done()).to.eql({});
        });
      });
      return context('when given an initial object', function(){
        beforeEach(function(){
          this.initialObject = {
            foo: 'foo'
          };
          return this.obi = obi(this.initialObject);
        });
        return o('returns the initial object', function(){
          return expect(this.obi.done()).to.eql(this.initialObject);
        });
      });
    });
    describe('#extend', function(){
      beforeEach(function(){
        return this.obi = obi();
      });
      context('when extend is not given an object', function(){
        return o('recursively calls obi with the initial object', function(){
          return expect(this.obi.extend().done()).to.eql({});
        });
      });
      return context('when extend is given an object', function(){
        return o('extends the initial object wrapped by obi', function(){
          return expect(this.obi.extend({
            foo: 'foo'
          }).done()).to.eql({
            foo: 'foo'
          });
        });
      });
    });
    return describe('immutability', function(){
      return context('when obi is given an object', function(){
        o('clones the object', function(){
          var foo;
          foo = {
            foo: 'foo'
          };
          return expect(obi(foo).done()).to.not.equal(foo);
        });
        return o('clones the nested properties of an object', function(){
          var foo, obj;
          foo = {
            foo: {
              bar: 'foo',
              baz: {
                fizz: 'buzz'
              }
            }
          };
          obj = obi(foo).done();
          return expect(obj.foo.baz).to.not.equal(foo.foo.baz);
        });
      });
    });
  });
}).call(this);
